// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from tuw_geo_msgs:msg/GeoJSON.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "tuw_geo_msgs/msg/detail/geo_json__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace tuw_geo_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void GeoJSON_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) tuw_geo_msgs::msg::GeoJSON(_init);
}

void GeoJSON_fini_function(void * message_memory)
{
  auto typed_message = static_cast<tuw_geo_msgs::msg::GeoJSON *>(message_memory);
  typed_message->~GeoJSON();
}

size_t size_function__GeoJSON__features(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<tuw_geo_msgs::msg::GeoJSONFeature> *>(untyped_member);
  return member->size();
}

const void * get_const_function__GeoJSON__features(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<tuw_geo_msgs::msg::GeoJSONFeature> *>(untyped_member);
  return &member[index];
}

void * get_function__GeoJSON__features(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<tuw_geo_msgs::msg::GeoJSONFeature> *>(untyped_member);
  return &member[index];
}

void fetch_function__GeoJSON__features(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const tuw_geo_msgs::msg::GeoJSONFeature *>(
    get_const_function__GeoJSON__features(untyped_member, index));
  auto & value = *reinterpret_cast<tuw_geo_msgs::msg::GeoJSONFeature *>(untyped_value);
  value = item;
}

void assign_function__GeoJSON__features(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<tuw_geo_msgs::msg::GeoJSONFeature *>(
    get_function__GeoJSON__features(untyped_member, index));
  const auto & value = *reinterpret_cast<const tuw_geo_msgs::msg::GeoJSONFeature *>(untyped_value);
  item = value;
}

void resize_function__GeoJSON__features(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<tuw_geo_msgs::msg::GeoJSONFeature> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember GeoJSON_message_member_array[3] = {
  {
    "header",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<std_msgs::msg::Header>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(tuw_geo_msgs::msg::GeoJSON, header),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "type",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_STRING,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(tuw_geo_msgs::msg::GeoJSON, type),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "features",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<tuw_geo_msgs::msg::GeoJSONFeature>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(tuw_geo_msgs::msg::GeoJSON, features),  // bytes offset in struct
    nullptr,  // default value
    size_function__GeoJSON__features,  // size() function pointer
    get_const_function__GeoJSON__features,  // get_const(index) function pointer
    get_function__GeoJSON__features,  // get(index) function pointer
    fetch_function__GeoJSON__features,  // fetch(index, &value) function pointer
    assign_function__GeoJSON__features,  // assign(index, value) function pointer
    resize_function__GeoJSON__features  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers GeoJSON_message_members = {
  "tuw_geo_msgs::msg",  // message namespace
  "GeoJSON",  // message name
  3,  // number of fields
  sizeof(tuw_geo_msgs::msg::GeoJSON),
  GeoJSON_message_member_array,  // message members
  GeoJSON_init_function,  // function to initialize message memory (memory has to be allocated)
  GeoJSON_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t GeoJSON_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &GeoJSON_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace tuw_geo_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<tuw_geo_msgs::msg::GeoJSON>()
{
  return &::tuw_geo_msgs::msg::rosidl_typesupport_introspection_cpp::GeoJSON_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, tuw_geo_msgs, msg, GeoJSON)() {
  return &::tuw_geo_msgs::msg::rosidl_typesupport_introspection_cpp::GeoJSON_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
