// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tuw_geo_msgs:msg/GeoJSONProperties.idl
// generated code does not contain a copyright notice

#ifndef TUW_GEO_MSGS__MSG__DETAIL__GEO_JSON_PROPERTIES__STRUCT_HPP_
#define TUW_GEO_MSGS__MSG__DETAIL__GEO_JSON_PROPERTIES__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__tuw_geo_msgs__msg__GeoJSONProperties __attribute__((deprecated))
#else
# define DEPRECATED__tuw_geo_msgs__msg__GeoJSONProperties __declspec(deprecated)
#endif

namespace tuw_geo_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct GeoJSONProperties_
{
  using Type = GeoJSONProperties_<ContainerAllocator>;

  explicit GeoJSONProperties_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0ul;
      this->type = 0ul;
    }
  }

  explicit GeoJSONProperties_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0ul;
      this->type = 0ul;
    }
  }

  // field types and members
  using _id_type =
    uint32_t;
  _id_type id;
  using _type_type =
    uint32_t;
  _type_type type;
  using _enflation_radius_type =
    std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>>;
  _enflation_radius_type enflation_radius;
  using _bondary_radius_type =
    std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>>;
  _bondary_radius_type bondary_radius;

  // setters for named parameter idiom
  Type & set__id(
    const uint32_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__type(
    const uint32_t & _arg)
  {
    this->type = _arg;
    return *this;
  }
  Type & set__enflation_radius(
    const std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> & _arg)
  {
    this->enflation_radius = _arg;
    return *this;
  }
  Type & set__bondary_radius(
    const std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> & _arg)
  {
    this->bondary_radius = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    tuw_geo_msgs::msg::GeoJSONProperties_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_geo_msgs::msg::GeoJSONProperties_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_geo_msgs::msg::GeoJSONProperties_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_geo_msgs::msg::GeoJSONProperties_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_geo_msgs::msg::GeoJSONProperties_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_geo_msgs::msg::GeoJSONProperties_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_geo_msgs::msg::GeoJSONProperties_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_geo_msgs::msg::GeoJSONProperties_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_geo_msgs::msg::GeoJSONProperties_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_geo_msgs::msg::GeoJSONProperties_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_geo_msgs__msg__GeoJSONProperties
    std::shared_ptr<tuw_geo_msgs::msg::GeoJSONProperties_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_geo_msgs__msg__GeoJSONProperties
    std::shared_ptr<tuw_geo_msgs::msg::GeoJSONProperties_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GeoJSONProperties_ & other) const
  {
    if (this->id != other.id) {
      return false;
    }
    if (this->type != other.type) {
      return false;
    }
    if (this->enflation_radius != other.enflation_radius) {
      return false;
    }
    if (this->bondary_radius != other.bondary_radius) {
      return false;
    }
    return true;
  }
  bool operator!=(const GeoJSONProperties_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GeoJSONProperties_

// alias to use template instance with default allocator
using GeoJSONProperties =
  tuw_geo_msgs::msg::GeoJSONProperties_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace tuw_geo_msgs

#endif  // TUW_GEO_MSGS__MSG__DETAIL__GEO_JSON_PROPERTIES__STRUCT_HPP_
