// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tuw_geo_msgs:msg/GeoJSON.idl
// generated code does not contain a copyright notice

#ifndef TUW_GEO_MSGS__MSG__DETAIL__GEO_JSON__STRUCT_HPP_
#define TUW_GEO_MSGS__MSG__DETAIL__GEO_JSON__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'features'
#include "tuw_geo_msgs/msg/detail/geo_json_feature__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__tuw_geo_msgs__msg__GeoJSON __attribute__((deprecated))
#else
# define DEPRECATED__tuw_geo_msgs__msg__GeoJSON __declspec(deprecated)
#endif

namespace tuw_geo_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct GeoJSON_
{
  using Type = GeoJSON_<ContainerAllocator>;

  explicit GeoJSON_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->type = "";
    }
  }

  explicit GeoJSON_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    type(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->type = "";
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _type_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _type_type type;
  using _features_type =
    std::vector<tuw_geo_msgs::msg::GeoJSONFeature_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<tuw_geo_msgs::msg::GeoJSONFeature_<ContainerAllocator>>>;
  _features_type features;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__type(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->type = _arg;
    return *this;
  }
  Type & set__features(
    const std::vector<tuw_geo_msgs::msg::GeoJSONFeature_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<tuw_geo_msgs::msg::GeoJSONFeature_<ContainerAllocator>>> & _arg)
  {
    this->features = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    tuw_geo_msgs::msg::GeoJSON_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_geo_msgs::msg::GeoJSON_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_geo_msgs::msg::GeoJSON_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_geo_msgs::msg::GeoJSON_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_geo_msgs::msg::GeoJSON_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_geo_msgs::msg::GeoJSON_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_geo_msgs::msg::GeoJSON_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_geo_msgs::msg::GeoJSON_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_geo_msgs::msg::GeoJSON_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_geo_msgs::msg::GeoJSON_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_geo_msgs__msg__GeoJSON
    std::shared_ptr<tuw_geo_msgs::msg::GeoJSON_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_geo_msgs__msg__GeoJSON
    std::shared_ptr<tuw_geo_msgs::msg::GeoJSON_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GeoJSON_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->type != other.type) {
      return false;
    }
    if (this->features != other.features) {
      return false;
    }
    return true;
  }
  bool operator!=(const GeoJSON_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GeoJSON_

// alias to use template instance with default allocator
using GeoJSON =
  tuw_geo_msgs::msg::GeoJSON_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace tuw_geo_msgs

#endif  // TUW_GEO_MSGS__MSG__DETAIL__GEO_JSON__STRUCT_HPP_
